#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *
import string, os, sys, re

class Prefs:
	def __init__(self, parent):
		self.parent = parent

	def show_config(self, *args):
		# our main gtk window
		window = GtkWindow(WINDOW_TOPLEVEL)
		self.parent.config_window = window
		window.connect("delete_event", window.hide)
		window.set_title("Storm - Prefs")
		if screen_width() > 300:
			window.set_usize(280, 240)
		else:
			window.set_usize(240, 280)
		window.set_name("window")
		rc_parse_string('widget "*window*" style "storm_normal"') 
		window.show()

		vbox = GtkVBox()
		window.add(vbox)
		vbox.show()
		userdatafile = open(self.parent.storm_userdatafile, 'r')
		raw = userdatafile.read()
		userdatafile.close()
		storm_config = string.split(raw, '\n')
		self.storm_config = storm_config
		sync_file = open(self.parent.storm_usercfgdir + 'sync', 'r')
		raw = sync_file.read()
		sync_config = string.split(raw, '\n')
		sync_file.close()
		smtp_file = open(self.parent.storm_usercfgdir + 'smtp', 'r')
		raw = smtp_file.read()
		smtp_config = string.split(raw, '\n')
		smtp_file.close()
		sig_file = open(self.parent.storm_usercfgdir + 'sig', 'r')
		sig = sig_file.read()
		sig_file.close()

		# - Get Animail config
		if os.path.exists('/usr/share/animail') > 0:
			ani_file = open(os.environ['HOME'] + '/.animail/animailrc', 'r')
			ani_raw_config = ani_file.read()
			ani_file.close()

			ani_config_re = re.compile('<server>([0-9A-Za-z \$\t\n\r<>\.@\-:,/\\\-_]*?)</server>')
			ani_server_conf_lines = re.findall(ani_config_re, ani_raw_config)

			ani_config_re = re.compile('<global>([0-9A-Za-z \$\t\n\r<>\.@\-:,/\\\-_]*?)</global>')
			ani_global_conf_lines = re.findall(ani_config_re, ani_raw_config)

			ani_conf_all = ani_server_conf_lines[0] + '\n' + ani_global_conf_lines[0]

			ani_config_username = ''
			ani_config_password = ''
			ani_config_host = ''
			self.ani_config_protocol = 'POP3'
			ani_config_protocol = 'POP3'
			ani_config_ssl = 'no'
			ani_config_port = '110'
			ani_config_keepmessages = 'yes'
			ani_config_maxsize = '0'
			ani_config_maxmessages = '0'

			ani_conf_lines = string.split(ani_conf_all, '\n')

			for ani_conf_line in ani_conf_lines:
				print ani_conf_line
				ani_conf_line_parts = string.split(ani_conf_line, ':')
				print ani_conf_line_parts

				if ani_conf_line_parts[0] == "UserName":
					if len(ani_conf_line_parts) > 0:
						ani_config_username = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "Password":
					if len(ani_conf_line_parts) > 0:
						ani_config_password = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "Address":
					if len(ani_conf_line_parts) > 0:
						ani_config_host = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "Protocol":
					if len(ani_conf_line_parts) > 0:
						ani_config_protocol = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "SSL":
					if len(ani_conf_line_parts) > 0:
						ani_config_ssl = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "Port":
					if len(ani_conf_line_parts) > 0:
						ani_config_port = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "KeepOnServer":
					if len(ani_conf_line_parts) > 0:
						ani_config_keepmessages = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "MaxSize":
					if len(ani_conf_line_parts) > 0:
						ani_config_maxsize = ani_conf_line_parts[1]

				elif ani_conf_line_parts[0] == "MaxNumber":
					if len(ani_conf_line_parts) > 0:
						ani_config_maxmessages = ani_conf_line_parts[1]

		toolbar = GtkToolbar(ORIENTATION_HORIZONTAL, TOOLBAR_ICONS)
		toolbar.set_button_relief(RELIEF_NONE)
		toolbar.set_space_size(10)
		vbox.pack_start(toolbar, expand=FALSE)
		toolbar.show()
		# add the evolution pixmaps to the toolbar
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/save.xpm")
		toolbar.append_item(None, 'Save preferences', None, GtkPixmap(pix, mask), self.save_config)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/cancel.xpm")
		toolbar.append_item(None, 'Close this window', None, GtkPixmap(pix, mask), window.hide)

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/help.xpm")
		toolbar.append_item(None, 'About', None, GtkPixmap(pix, mask), self.parent.help.about)

		self.notebook = GtkNotebook()
		vbox.pack_start(self.notebook)
		self.notebook.show()

		mail_label = GtkLabel("User")
		mail_label.show()

		table1=GtkTable(2, 3)
		self.notebook.append_page(table1, mail_label)
		table1.set_usize(-1, -1)
		table1.set_row_spacings(0)
		table1.set_col_spacings(0)
		label1=GtkLabel()
		table1.attach(label1, 0, 1, 0, 1, FILL, 0, 0, 0)
		label1.set_usize(-1, -1)
		label1.set_text("Name")
		label1.set_justify(JUSTIFY_CENTER)
		label1.set_alignment(0, 0.5)
		label1.set_padding(0, 0)
		label1.show()
		self.label1=label1
		label2=GtkLabel()
		table1.attach(label2, 0, 1, 1, 2, FILL, 0, 0, 0)
		label2.set_usize(-1, -1)
		label2.set_text("E-Mail")
		label2.set_justify(JUSTIFY_CENTER)
		label2.set_alignment(0, 0.5)
		label2.set_padding(0, 0)
		label2.show()
		self.label2=label2
		label11=GtkLabel()
		table1.attach(label11, 0, 1, 2, 3, FILL, 0, 0, 0)
		label11.set_usize(-1, -1)
		label11.set_text("Signature")
		label11.set_justify(JUSTIFY_CENTER)
		label11.set_alignment(0, 0.5)
		label11.set_padding(0, 0)
		label11.show()
		self.label11=label11
		entry_username=GtkEntry()
		table1.attach(entry_username, 1, 2, 0, 1, EXPAND, 0, 0, 0)
		entry_username.set_flags(CAN_FOCUS)
		entry_username.set_usize(120, -1)
		entry_username.set_editable(TRUE)
		entry_username.set_visibility(TRUE)
		entry_username.set_max_length(0)
		entry_username.set_text(storm_config[0])
		entry_username.show()
		self.entry_username=entry_username
		entry_useremail=GtkEntry()
		table1.attach(entry_useremail, 1, 2, 1, 2, EXPAND, 0, 0, 0)
		entry_useremail.set_flags(CAN_FOCUS)
		entry_useremail.set_usize(120, -1)
		entry_useremail.set_editable(TRUE)
		entry_useremail.set_visibility(TRUE)
		entry_useremail.set_max_length(0)
		entry_useremail.set_text(storm_config[1])
		entry_useremail.show()
		self.entry_useremail=entry_useremail
		scroll1 = GtkScrolledWindow()
		table1.attach(scroll1, 1, 2, 2, 3, EXPAND, 0, 0, 0)
		scroll1.set_usize(120, -1)
		scroll1.set_policy(POLICY_NEVER, POLICY_AUTOMATIC)
		scroll1.show()
		self.scroll1 = scroll1
		text_sig = GtkText()
		scroll1.add(text_sig)
		text_sig.set_usize(120, -1)
		text_sig.set_editable(TRUE)
		text_sig.insert(None, None, None, sig)
		text_sig.show()
		self.text_sig = text_sig
		table1.show()
		self.table1=table1

		sync_label = GtkLabel("Sync")
		sync_label.show()

		table2=GtkTable(4, 2)
		self.notebook.append_page(table2, sync_label)
		table2.set_usize(-1, -1)
		table2.set_row_spacings(0)
		table2.set_col_spacings(0)
		label3=GtkLabel()
		table2.attach(label3, 0, 1, 0, 1, FILL, 0, 0, 0)
		label3.set_usize(-1, -1)
		label3.set_text("Username")
		label3.set_justify(JUSTIFY_CENTER)
		label3.set_alignment(0, 0.5)
		label3.set_padding(0, 0)
		label3.show()
		self.label3=label3
		label4=GtkLabel()
		table2.attach(label4, 0, 1, 1, 2, FILL, 0, 0, 0)
		label4.set_usize(-1, -1)
		label4.set_text("Host IP")
		label4.set_justify(JUSTIFY_CENTER)
		label4.set_alignment(0, 0.5)
		label4.set_padding(0, 0)
		label4.show()
		self.label4=label4
		label5=GtkLabel()
		table2.attach(label5, 0, 1, 2, 3, FILL, 0, 0, 0)
		label5.set_usize(-1, -1)
		label5.set_text("Incoming")
		label5.set_justify(JUSTIFY_CENTER)
		label5.set_alignment(0, 0.5)
		label5.set_padding(0, 0)
		label5.show()
		self.label5=label5
		label6=GtkLabel()
		table2.attach(label6, 0, 1, 3, 4, FILL, 0, 0, 0)
		label6.set_usize(-1, -1)
		label6.set_text("Outgoing")
		label6.set_justify(JUSTIFY_CENTER)
		label6.set_alignment(0, 0.5)
		label6.set_padding(0, 0)
		label6.show()
		self.label6=label6
		entry4=GtkEntry()
		table2.attach(entry4, 1, 2, 1, 2, EXPAND, 0, 0, 0)
		entry4.set_flags(CAN_FOCUS)
		entry4.set_usize(120, -1)
		entry4.set_editable(TRUE)
		entry4.set_visibility(TRUE)
		entry4.set_max_length(0)
		entry4.set_text(sync_config[1])
		entry4.show()
		self.entry4=entry4
		entry5=GtkEntry()
		table2.attach(entry5, 1, 2, 2, 3, EXPAND, 0, 0, 0)
		entry5.set_flags(CAN_FOCUS)
		entry5.set_usize(120, -1)
		entry5.set_editable(TRUE)
		entry5.set_visibility(TRUE)
		entry5.set_max_length(0)
		entry5.set_text(sync_config[2])
		entry5.show()
		self.entry5=entry5
		entry6=GtkEntry()
		table2.attach(entry6, 1, 2, 3, 4, EXPAND, 0, 0, 0)
		entry6.set_flags(CAN_FOCUS)
		entry6.set_usize(120, -1)
		entry6.set_editable(TRUE)
		entry6.set_visibility(TRUE)
		entry6.set_max_length(0)
		entry6.set_text(sync_config[3])
		entry6.show()
		self.entry6=entry6
		entry3=GtkEntry()
		table2.attach(entry3, 1, 2, 0, 1, EXPAND, 0, 0, 0)
		entry3.set_flags(CAN_FOCUS)
		entry3.set_usize(120, -1)
		entry3.set_editable(TRUE)
		entry3.set_visibility(TRUE)
		entry3.set_max_length(0)
		entry3.set_text(sync_config[0])
		entry3.show()
		self.entry3=entry3
		table2.show()
		self.table2=table2

		smtp_label = GtkLabel("SMTP")
		smtp_label.show()

		table4=GtkTable(1, 2)
		self.notebook.append_page(table4, smtp_label)
		table4.set_usize(-1, -1)
		table4.set_row_spacings(0)
		table4.set_col_spacings(0)
		label_smtpserver=GtkLabel()
		table4.attach(label_smtpserver, 0, 1, 0, 1, FILL, 0, 0, 0)
		label_smtpserver.set_usize(-1, -1)
		label_smtpserver.set_text("Server")
		label_smtpserver.set_justify(JUSTIFY_CENTER)
		label_smtpserver.set_alignment(0, 0.5)
		label_smtpserver.set_padding(0, 0)
		label_smtpserver.show()
		self.label_smtpserver=label_smtpserver
		entry_smtpserver=GtkEntry()
		table4.attach(entry_smtpserver, 1, 2, 0, 1, EXPAND, 0, 0, 0)
		entry_smtpserver.set_flags(CAN_FOCUS)
		entry_smtpserver.set_usize(120, -1)
		entry_smtpserver.set_editable(TRUE)
		entry_smtpserver.set_visibility(TRUE)
		entry_smtpserver.set_max_length(0)
		entry_smtpserver.set_text(smtp_config[0])
		entry_smtpserver.show()
		self.entry_smtpserver=entry_smtpserver
		table4.show()
		self.table4=table4

		animail_label = GtkLabel("Animail (POP3/IMAP4)")
		animail_label.show()

		if os.path.exists('/usr/share/animail') <= 0:
			animail_vbox = GtkVBox()
			self.notebook.append_page(animail_vbox, animail_label)
			animail_vbox.show()

			animail_label2 = GtkLabel("It seems you don't have Animail installed.\nAnimail is a python program\nthat Storm can use for fetching email messages.\n\nClick the button below to install Animail now.\nPlease make sure your iPAQ\ncurrently has access to the Internet.")
			animail_vbox.pack_start(animail_label2, expand=FALSE)
			animail_label2.show()

			animail_button = GtkButton("Install Animail")
			animail_button.connect("clicked", self.install_animail)
			animail_vbox.pack_end(animail_button, expand=FALSE)
			animail_button.show()

		else:
			ani_vbox1=GtkVBox()
			ani_scroll = GtkScrolledWindow()
			ani_scroll.add_with_viewport(ani_vbox1)
			self.notebook.append_page(ani_scroll, animail_label)
			ani_scroll.show()
			ani_vbox1.set_usize(-1, -1)
			ani_vbox1.set_homogeneous(FALSE)
			ani_vbox1.set_spacing(0)
			ani_table1=GtkTable(6, 2)
			ani_vbox1.pack_start(ani_table1, FALSE, TRUE, 0)
			ani_table1.set_usize(-1, -1)
			ani_table1.set_row_spacings(0)
			ani_table1.set_col_spacings(0)
			ani_label_username=GtkLabel()
			ani_table1.attach(ani_label_username, 0, 1, 0, 1, FILL, 0, 0, 0)
			ani_label_username.set_usize(-1, -1)
			ani_label_username.set_text("Username")
			ani_label_username.set_justify(JUSTIFY_CENTER)
			ani_label_username.set_alignment(0, 0.5)
			ani_label_username.set_padding(0, 0)
			ani_label_username.show()
			self.ani_label_username=ani_label_username
			ani_label_password=GtkLabel()
			ani_table1.attach(ani_label_password, 0, 1, 1, 2, FILL, 0, 0, 0)
			ani_label_password.set_usize(-1, -1)
			ani_label_password.set_text("Password")
			ani_label_password.set_justify(JUSTIFY_CENTER)
			ani_label_password.set_alignment(0, 0.5)
			ani_label_password.set_padding(0, 0)
			ani_label_password.show()
			self.ani_label_password=ani_label_password
			ani_label_host=GtkLabel()
			ani_table1.attach(ani_label_host, 0, 1, 2, 3, FILL, 0, 0, 0)
			ani_label_host.set_usize(-1, -1)
			ani_label_host.set_text("Host")
			ani_label_host.set_justify(JUSTIFY_CENTER)
			ani_label_host.set_alignment(0, 0.5)
			ani_label_host.set_padding(0, 0)
			ani_label_host.show()
			self.ani_label_host=ani_label_host
			ani_label_port=GtkLabel()
			ani_table1.attach(ani_label_port, 0, 1, 3, 4, FILL, 0, 0, 0)
			ani_label_port.set_usize(-1, -1)
			ani_label_port.set_text("Port")
			ani_label_port.set_justify(JUSTIFY_CENTER)
			ani_label_port.set_alignment(0, 0.5)
			ani_label_port.set_padding(0, 0)
			ani_label_port.show()
			self.ani_label_port=ani_label_port
			ani_label_protocol=GtkLabel()
			ani_table1.attach(ani_label_protocol, 0, 1, 4, 5, FILL, 0, 0, 0)
			ani_label_protocol.set_usize(-1, -1)
			ani_label_protocol.set_text("Protocol")
			ani_label_protocol.set_justify(JUSTIFY_CENTER)
			ani_label_protocol.set_alignment(0, 0.5)
			ani_label_protocol.set_padding(0, 0)
			ani_label_protocol.show()
			self.ani_label_protocol=ani_label_protocol
			ani_label_ssl=GtkLabel()
			ani_table1.attach(ani_label_ssl, 0, 1, 5, 6, FILL, 0, 0, 0)
			ani_label_ssl.set_usize(-1, -1)
			ani_label_ssl.set_text("SSL")
			ani_label_ssl.set_justify(JUSTIFY_CENTER)
			ani_label_ssl.set_alignment(0, 0.5)
			ani_label_ssl.set_padding(0, 0)
			ani_label_ssl.show()
			self.ani_label_ssl=ani_label_ssl
			ani_entry_username=GtkEntry()
			ani_table1.attach(ani_entry_username, 1, 2, 0, 1, EXPAND, 0, 0, 0)
			ani_entry_username.set_flags(CAN_FOCUS)
			ani_entry_username.set_usize(120, -1)
			ani_entry_username.set_editable(TRUE)
			ani_entry_username.set_visibility(TRUE)
			ani_entry_username.set_max_length(0)
			ani_entry_username.set_text(ani_config_username)
			ani_entry_username.show()
			self.ani_entry_username=ani_entry_username
			ani_entry_password=GtkEntry()
			ani_table1.attach(ani_entry_password, 1, 2, 1, 2, EXPAND, 0, 0, 0)
			ani_entry_password.set_flags(CAN_FOCUS)
			ani_entry_password.set_usize(120, -1)
			ani_entry_password.set_editable(TRUE)
			ani_entry_password.set_visibility(TRUE)
			ani_entry_password.set_max_length(0)
			ani_entry_password.set_text(ani_config_password)
			ani_entry_password.show()
			self.ani_entry_password=ani_entry_password
			ani_entry_host=GtkEntry()
			ani_table1.attach(ani_entry_host, 1, 2, 2, 3, EXPAND, 0, 0, 0)
			ani_entry_host.set_flags(CAN_FOCUS)
			ani_entry_host.set_usize(120, -1)
			ani_entry_host.set_editable(TRUE)
			ani_entry_host.set_visibility(TRUE)
			ani_entry_host.set_max_length(0)
			ani_entry_host.set_text(ani_config_host)
			ani_entry_host.show()
			self.ani_entry_host=ani_entry_host
			ani_optionmenu_protocol=GtkOptionMenu()
			ani_table1.attach(ani_optionmenu_protocol, 1, 2, 4, 5, EXPAND, 0, 0, 0)
			ani_optionmenu_protocol.set_flags(CAN_FOCUS)
			ani_optionmenu_protocol.set_usize(120, -1)
			menu = GtkMenu()
			menulist = []
			menuitem = GtkMenuItem("POP3")
			menuitem.connect("activate", self.animail_select_protocol, "POP3")
			menuitemdata = [self, 0]
			menulist.append("POP3")
			menu.append(menuitem)
			menuitem.show()
			menuitem = GtkMenuItem("IMAP4")
			menuitem.connect("activate", self.animail_select_protocol, "IMAP4")
			menuitemdata = [self, 1]
			menulist.append("IMAP4")
			menu.append(menuitem)
			menuitem.show()
			menuitem = GtkMenuItem("APOP")
			menuitem.connect("activate", self.animail_select_protocol, "APOP")
			menuitemdata = [self, 2]
			menulist.append("APOP")
			menu.append(menuitem)
			menuitem.show()
			ani_optionmenu_protocol.menulist = menulist
			ani_optionmenu_protocol.set_menu(menu)

			# - Select the correct menu entry from the config
			if ani_config_protocol == "POP3":
				ani_config_protocol_num = 0
			elif ani_config_protocol == "IMAP4":
				ani_config_protocol_num = 1
			elif ani_config_protocol == "APOP":
				ani_config_protocol_num = 2

			ani_optionmenu_protocol.set_history(ani_config_protocol_num)
			ani_optionmenu_protocol.show()
			self.ani_optionmenu_protocol=ani_optionmenu_protocol
			ani_combo_port=GtkCombo()
			ani_table1.attach(ani_combo_port, 1, 2, 3, 4, EXPAND, 0, 0, 0)
			ani_combo_port.set_usize(120, -1)
			ani_combo_port.set_homogeneous(FALSE)
			ani_combo_port.set_spacing(0)
			ani_combo_port.set_case_sensitive(FALSE)
			ani_combo_port.set_use_arrows(TRUE)
			ani_combo_port.set_use_arrows_always(FALSE)
			ani_combo_port.set_popdown_strings(['110', '995', '143'])
			ani_combo_port.entry.set_text(ani_config_port)
			ani_combo_port.show()
			self.ani_combo_port=ani_combo_port
			ani_checkbutton_ssl=GtkCheckButton("")
			ani_table1.attach(ani_checkbutton_ssl, 1, 2, 5, 6, EXPAND, 0, 0, 0)
			ani_checkbutton_ssl.set_flags(CAN_FOCUS)
			ani_checkbutton_ssl.set_usize(120, -1)
			
			# - If the config SSL is yes, enable the checkbutton
			if ani_config_ssl == "yes":
				ani_checkbutton_ssl.set_active(TRUE)

			ani_checkbutton_ssl.show()
			self.ani_checkbutton_ssl=ani_checkbutton_ssl
			ani_table1.show()
			self.ani_table1=ani_table1
			hseparator1=GtkHSeparator()
			ani_vbox1.pack_start(hseparator1, FALSE, TRUE, 0)
			hseparator1.set_usize(-1, -1)
			hseparator1.show()
			self.hseparator1=hseparator1
			ani_table2=GtkTable(4, 2)
			ani_vbox1.pack_start(ani_table2, TRUE, TRUE, 0)
			ani_table2.set_usize(-1, -1)
			ani_table2.set_row_spacings(0)
			ani_table2.set_col_spacings(0)
			ani_label_maxnum=GtkLabel()
			ani_table2.attach(ani_label_maxnum, 0, 1, 1, 2, FILL, 0, 0, 0)
			ani_label_maxnum.set_usize(-1, -1)
			ani_label_maxnum.set_text("Max num messages")
			ani_label_maxnum.set_justify(JUSTIFY_CENTER)
			ani_label_maxnum.set_alignment(0, 0.5)
			ani_label_maxnum.set_padding(0, 0)
			ani_label_maxnum.show()
			self.ani_label_maxnum=ani_label_maxnum
			label8=GtkLabel()
			ani_table2.attach(label8, 0, 1, 2, 3, FILL, 0, 0, 0)
			label8.set_usize(-1, -1)
			label8.set_text("Max message size")
			label8.set_justify(JUSTIFY_CENTER)
			label8.set_alignment(0, 0.5)
			label8.set_padding(0, 0)
			label8.show()
			self.label8=label8
			label9=GtkLabel()
			ani_table2.attach(label9, 0, 1, 3, 4, FILL, 0, 0, 0)
			label9.set_usize(-1, -1)
			label9.set_text("Delivery folder")
			label9.set_justify(JUSTIFY_CENTER)
			label9.set_alignment(0, 0.5)
			label9.set_padding(0, 0)
			label9.show()
			self.label9=label9
			ani_entry_maxmessages=GtkEntry()
			ani_table2.attach(ani_entry_maxmessages, 1, 2, 1, 2, EXPAND, 0, 0, 0)
			ani_entry_maxmessages.set_flags(CAN_FOCUS)
			ani_entry_maxmessages.set_usize(120, -1)
			ani_entry_maxmessages.set_editable(TRUE)
			ani_entry_maxmessages.set_visibility(TRUE)
			ani_entry_maxmessages.set_max_length(0)
			ani_entry_maxmessages.set_text(ani_config_maxmessages)
			ani_entry_maxmessages.show()
			self.ani_entry_maxmessages=ani_entry_maxmessages
			ani_entry_maxmessagesize=GtkEntry()
			ani_table2.attach(ani_entry_maxmessagesize, 1, 2, 2, 3, EXPAND, 0, 0, 0)
			ani_entry_maxmessagesize.set_flags(CAN_FOCUS)
			ani_entry_maxmessagesize.set_usize(120, -1)
			ani_entry_maxmessagesize.set_editable(TRUE)
			ani_entry_maxmessagesize.set_visibility(TRUE)
			ani_entry_maxmessagesize.set_max_length(0)
			ani_entry_maxmessagesize.set_text(ani_config_maxsize)
			ani_entry_maxmessagesize.show()
			self.ani_entry_maxmessagesize=ani_entry_maxmessagesize
			ani_optionmenu_deliverfolder=GtkOptionMenu()
			ani_table2.attach(ani_optionmenu_deliverfolder, 1, 2, 3, 4, EXPAND, 0, 0, 0)
			ani_optionmenu_deliverfolder.set_flags(CAN_FOCUS)
			ani_optionmenu_deliverfolder.set_usize(120, -1)

			#TODO: Add real multiple folder support
			menu = GtkMenu()
			menulist = []
			menuitem = GtkMenuItem("Inbox")
			menuitemdata = [self, 0]
			menulist.append("Inbox")
			menu.append(menuitem)
			menuitem.show()
			ani_optionmenu_deliverfolder.menulist = menulist
			ani_optionmenu_deliverfolder.set_menu(menu)
			ani_optionmenu_deliverfolder.set_history(0)
			ani_optionmenu_deliverfolder.show()
			self.ani_optionmenu_deliverfolder=ani_optionmenu_deliverfolder
			ani_label_keepmessages=GtkLabel()
			ani_table2.attach(ani_label_keepmessages, 0, 1, 0, 1, FILL, 0, 0, 0)
			ani_label_keepmessages.set_usize(-1, -1)
			ani_label_keepmessages.set_text("Leave messages on server")
			ani_label_keepmessages.set_justify(JUSTIFY_CENTER)
			ani_label_keepmessages.set_alignment(0, 0.5)
			ani_label_keepmessages.set_padding(0, 0)
			ani_label_keepmessages.show()
			self.ani_label_keepmessages=ani_label_keepmessages
			ani_checkbutton_keepmessages=GtkCheckButton("")
			ani_table2.attach(ani_checkbutton_keepmessages, 1, 2, 0, 1, EXPAND, 0, 0, 0)
			ani_checkbutton_keepmessages.set_flags(CAN_FOCUS)
			ani_checkbutton_keepmessages.set_usize(120, -1)
			
			# - If the config KeepMessages is yes, enable the checkbutton
			if ani_config_keepmessages == "yes":
				ani_checkbutton_keepmessages.set_active(TRUE)

			ani_checkbutton_keepmessages.show()
			self.ani_checkbutton_keepmessages=ani_checkbutton_keepmessages
			ani_table2.show()
			self.ani_table2=ani_table2
			ani_vbox1.show()
			self.ani_vbox1=ani_vbox1

	def install_animail(self, *args):
		'''Use ipkg to install the Animail program.'''

		os.system("rxvt -e ipkg install animail")

	def animail_select_protocol(self, *args):
		self.ani_config_protocol = args[1]

	def save_config(self, *args):
		text_username = self.entry_username.get_text()
		text_useremail = self.entry_useremail.get_text()
		text3 = self.entry3.get_text()
		text4 = self.entry4.get_text()
		text5 = self.entry5.get_text()
		text6 = self.entry6.get_text()
		text_smtpserver = self.entry_smtpserver.get_text()
		userdatafile = open(self.parent.storm_userdatafile, 'w')
		userdatafile.write(text_username + '\n' + text_useremail + '\n' + self.storm_config[2])
		userdatafile.close()
		sync_file = open(self.parent.storm_usercfgdir + 'sync', 'w')
		sync_file.write(text3 + '\n' + text4 + '\n' + text5 + '\n' + text6)
		sync_file.close()
		smtp_file = open(self.parent.storm_usercfgdir + 'smtp', 'w')
		smtp_file.write(text_smtpserver)
		smtp_file.close()
		sig_file = open(self.parent.storm_usercfgdir + 'sig', 'w')
		sig_file.write(self.text_sig.get_chars(0, -1))
		sig_file.close()

		if os.path.exists('/usr/share/animail') > 0:
			if self.ani_checkbutton_ssl.get_active() == TRUE:
				ani_config_ssl = 'yes'
			else:
				ani_config_ssl = 'no'

			if self.ani_checkbutton_keepmessages.get_active() == TRUE:
				ani_config_keepmessages = 'yes'
			else:
				ani_config_keepmessages = 'no'

			ani_file = open(os.environ['HOME'] + '/.animail/animailrc', 'w')
			ani_file.write('<server>\nAddress:' + self.ani_entry_host.get_text() + '\nProtocol:' + self.ani_config_protocol + '\nSSL:' + ani_config_ssl + '\nPort:' + self.ani_combo_port.entry.get_text() + '\nUserName:' + self.ani_entry_username.get_text() + '\nPassword:' + self.ani_entry_password.get_text() + '\nKeepOnServer:' + ani_config_keepmessages + '\nMaildir:$HOME/Maildir/Inbox\n</server>\n<global>\nMaxSize:' + self.ani_entry_maxmessagesize.get_text() + '\nMaxNumber:' + self.ani_entry_maxmessages.get_text() + '\n</global>')
			ani_file.close()

		self.parent.get_config()
		self.parent.config_window.hide()
