#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *
import rfc822, time, os, smtplib, string, re

class Sync:
	def __init__(self, parent):
		self.parent = parent

	def host(self, *args):
		'''Syncs with the host (comming soon).'''

		# our main gtk window
		window = GtkWindow(WINDOW_TOPLEVEL)
		window.connect("delete_event", window.hide)
		window.set_title("Storm - Sync")
		window.set_usize(200, -1)
        	window.set_position(WIN_POS_CENTER)
		window.show()

		hbox = GtkHBox()
		window.add(hbox)
		hbox.show()

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/send-receive.xpm")
		pixmap = GtkPixmap(pix, mask)
		hbox.pack_start(pixmap)
		pixmap.show()

		label = GtkLabel()
		hbox.pack_start(label)
		label.set_text("Feature Coming Soon...")
		label.show()

		config_file = open(self.parent.storm_usercfgdir + 'sync')
		lines = config_file.readlines()
		sync_config = []
		for cline in lines:
			sync_config.append(string.strip(cline))
		config_file.close()

		while events_pending(): mainiteration()
		time.sleep(3)

		window.hide()

	def get_mail(self, *args):
		'''Calls Animail in an rxvt window to recieve messages.'''

		os.system("rxvt -e /usr/share/animail")

	def send_mail(self, *args):
		'''Sends any messages in the outbox via SMTP.'''

		# our main gtk window
		window = GtkWindow(WINDOW_TOPLEVEL)
		window.connect("delete_event", window.hide)
		window.set_title("Storm - SMTP")
		window.set_usize(200, -1)
		window.show()

		hbox = GtkHBox()
		window.add(hbox)
		hbox.show()

		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/send-receive.xpm")
		pixmap = GtkPixmap(pix, mask)
		hbox.pack_start(pixmap)
		pixmap.show()

		label = GtkLabel()
		hbox.pack_start(label)
		label.set_text("Sending Messages...")
		label.show()

		while events_pending(): mainiteration()

		# - Get smtp config for username, password and server
		config_file = open(self.parent.storm_usercfgdir + 'smtp', 'r')
		lines = config_file.readlines()
		smtp_config = []
		for cline in lines:
			smtp_config.append(string.strip(cline))
		config_file.close()

		while events_pending(): mainiteration()

		try:

			# - Try and connect to the SMTP server
			smtp = smtplib.SMTP(smtp_config[0])
			smtp.helo()
			while events_pending(): mainiteration()

		except smtplib.SMTPConnectError:

			label.set_text("Error connecting to SMTP server")
			while events_pending(): mainiteration()
			time.sleep(2)
			window.hide()

		except:

			label.set_text("Error connecting to SMTP server")
			while events_pending(): mainiteration()
			time.sleep(2)
			window.hide()

		x = 0

		# - Check both maildir subdirectorys
		for maildir_folder in ['new','cur']:

			# - List the messsages in each directory
			messages = os.listdir(self.parent.storm_usermaildirdir + 'Outbox/' + maildir_folder)

			for message_file in messages:

				# - Open and read each message
				file = open(self.parent.storm_usermaildirdir + 'Outbox/' + maildir_folder + '/' + message_file)
				full_message = file.read()
				file.close()

				# - Extract the headers and write them to a temp file
				message_parts = string.split(full_message, '\n\n', 1)
				tmp_file = open("/tmp/storm.tmp", 'w')
				tmp_file.write(message_parts[0])
				tmp_file.close()
				tmp_file = open("/tmp/storm.tmp", 'r')

				# - Use the rfc822 module to extract the from and to headers
				header = rfc822.Message(tmp_file)
				mfrom = header.getheader("From")
				mto = header.getheader("To")

				tmp_file.close()

				try:

					while events_pending(): mainiteration()

					# - Try and send the message
					smtp.sendmail(mfrom, mto, message_parts[1])

					# - Delete the maildir message file
					os.unlink(self.parent.storm_usermaildirdir + 'Outbox/' + maildir_folder + '/' + message_file)

				except smtplib.SMTPRecipientsRefused:

					while events_pending(): mainiteration()
					label.set_text("Error sending message to " + mto)
					time.sleep(1)

				while events_pending(): mainiteration()

				# - Say that we've sent the message
				label.set_text("Sending Message " + str(x) + "...")

				x = x + 1
		try:
			smtp.quit()
			while events_pending(): mainiteration()
		except:
			pass

		self.parent.today.update_today()
		window.hide()
