#!/usr/bin/env python
# Storm mini Evolution clone by Damien Tanner (dctanner@xoasis.com)      
#
# This file is part of Storm.
#
#    Storm is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by 
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Storm is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Storm; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *
from modules.storm_constants import *
import time, string, os

class Today:
	def __init__(self, parent):
		self.parent = parent

		date = time.strftime("%d %b %Y", time.localtime(time.time()))
		self.day, self.month, self.year = string.split(date)

		frame = GtkFrame()
		frame.set_usize(-1, -1)
		frame.set_shadow_type("GTK_SHADOW_ETCHED_IN")		
		frame.set_name("today_frame")
		# make the label of the whole frame bold
		rc_parse_string('widget "*today_frame*" style "storm_today_title"') 

		# need to explicitly set the name of the other
		# labels with *.set_name("..._label") for this to
		# work, otherwise they will appear in bold! (or
		# maybe, just "*" instead of "*label*" would help
		# too...)		
		rc_parse_string('widget "*label*" style "storm_normal"') 

# Some stuff I tried to get the current font. raster tells me I cannot get it.
# Damn.

#                colin = GtkFontSelection()
#                myfont = colin.get_font_name()
#                print "myfont"
#                print myfont
#                print "myfont"
#
#		font = load_font("-*-*-bold-*-*-*-*-*-*-*-*-*-*-*")
#		style = frame.get_style().copy()
#		style.font = font
#		frame.set_style(style)

##         l = gtk.GtkLabel("MyLabel")
##         style = l.get_style().copy()
##         # Now change:
##         #    style.font.
##         #    style.font.ascent
##         #    style.font.descent
##         #    style.font.extents
##         #    style.font.height
##         #    style.font.measure
##         #    style.font.type
##         #    style.font.width
##         l.set_style(style)

# raster tells me I could parse the gtkrc though. Not a bad idea,
# but I don't know how to do that. The C function is gtk_rc_parse().

# struct GtkRcStyle
# {
#   gchar *name;
#   gchar *font_name;
#   gchar *fontset_name;
#   gchar *bg_pixmap_name[5];
# 
#   GtkRcFlags color_flags[5];
#   GdkColor   fg[5];
#   GdkColor   bg[5];
#   GdkColor   text[5];
#   GdkColor   base[5];
# 
#   GtkThemeEngine *engine;
#   gpointer        engine_data;
# 
#   /* Private */
#   guint ref_count;
# };


		storm_file = open(self.parent.storm_userdatafile, 'r')
		raw = storm_file.read()
		storm_config = string.split(raw, '\n')
		storm_file.close()
		self.storm_config = storm_config
		user_name = storm_config[0]
		user_email = storm_config[1]
		
		vbox1=GtkVBox()
		frame.add(vbox1)
		vbox1.set_usize(-1, -1)
		vbox1.set_homogeneous(FALSE)
		vbox1.set_spacing(0)


		hbox_username=GtkHBox()
		vbox1.pack_start(hbox_username, TRUE, TRUE, 0)
		hbox_username.set_usize(-1, -1)
		hbox_username.set_homogeneous(FALSE)
		hbox_username.set_spacing(0)
		username_label=GtkLabel()
		username_label.set_name("username_label")
		rc_parse_string('widget "*username_label*" style "storm_username"') 
		hbox_username.pack_start(username_label, FALSE, FALSE, 0)
		username_label.set_usize(-1, -1)
		username_label.set_text("Info for " + user_name)
#		username_label.set_text("Info for " + user_name + "<" + user_email + ">")
		username_label.set_justify(JUSTIFY_LEFT)
		username_label.set_alignment(0.5, 0.5)
		username_label.set_padding(5, -5)
		username_label.show()
		self.username_label=username_label
		hbox_username.show()
		self.hbox_username=hbox_username

		hbox1=GtkHBox()
		vbox1.pack_start(hbox1, TRUE, TRUE, 0)
		hbox1.set_usize(-1, -1)
		hbox1.set_homogeneous(FALSE)
		hbox1.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-today.xpm")
		today_pixmap=GtkPixmap(pix, mask)
		hbox1.pack_start(today_pixmap, FALSE, FALSE, 0)
		today_pixmap.set_usize(-1, -1)
		today_pixmap.set_alignment(0.5, 0.5)
		today_pixmap.set_padding(5, 0)
		today_pixmap.show()
		self.today_pixmap=today_pixmap
		today_label=GtkLabel()
		today_label.set_name("today_label")
#		rc_parse_string('widget "*today_label*" style "storm_normal"') 
		hbox1.pack_start(today_label, FALSE, FALSE, 0)
		today_label.set_usize(-1, -1)
		date_file = open(self.parent.storm_usercfgdir + "lastsync", 'r')
		# strip trailing white space after reading:
		thedate = string.rstrip(date_file.read())
		date_file.close()
		today_label.set_text("Last synchronized:\n" + thedate)
		today_label.set_justify(JUSTIFY_LEFT)
		today_label.set_alignment(0.5, 0.5)
		today_label.set_padding(0, 0)
		today_label.show()
		self.today_label=today_label
		hbox1.show()
		self.hbox1=hbox1

		hbox2=GtkHBox()
		vbox1.pack_start(hbox2, TRUE, TRUE, 0)
		hbox2.set_usize(-1, -1)
		hbox2.set_homogeneous(FALSE)
		hbox2.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-inbox.xpm")
		inbox_pixmap=GtkPixmap(pix, mask)
		hbox2.pack_start(inbox_pixmap, FALSE, FALSE, 0)
		inbox_pixmap.set_usize(-1, -1)
		inbox_pixmap.set_alignment(0.5, 0.5)
		inbox_pixmap.set_padding(5, 0)
		inbox_pixmap.show()
		self.inbox_pixmap=inbox_pixmap
		inbox_label=GtkLabel()
		inbox_label.set_name("inbox_label")
#		rc_parse_string('widget "*inbox_label*" style "storm_normal"') 
		hbox2.pack_start(inbox_label, FALSE, FALSE, 0)
		inbox_label.set_usize(-1, -1)
		inbox_label.set_justify(JUSTIFY_LEFT)
		inbox_label.set_alignment(0.5, 0.5)
		inbox_label.set_padding(0, 0)
		inbox_label.show()
		self.inbox_label=inbox_label
		hbox2.show()
		self.hbox2=hbox2

		hbox3=GtkHBox()
		vbox1.pack_start(hbox3, TRUE, TRUE, 0)
		hbox3.set_usize(-1, -1)
		hbox3.set_homogeneous(FALSE)
		hbox3.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-calendar.xpm")
		calendar_pixmap=GtkPixmap(pix, mask)
		hbox3.pack_start(calendar_pixmap, FALSE, FALSE, 0)
		calendar_pixmap.set_usize(-1, -1)
		calendar_pixmap.set_alignment(0.5, 0.5)
		calendar_pixmap.set_padding(5, 0)
		calendar_pixmap.show()
		self.calendar_pixmap=calendar_pixmap
		calendar_label=GtkLabel()
		calendar_label.set_name("calendar_label")
#		rc_parse_string('widget "*calendar_label*" style "storm_normal"') 
		hbox3.pack_start(calendar_label, FALSE, FALSE, 0)
		calendar_label.set_usize(-1, -1)
		calendar_label.set_justify(JUSTIFY_LEFT)
		calendar_label.set_alignment(0.5, 0.5)
		calendar_label.set_padding(0, 0)
		calendar_label.show()
		self.calendar_label=calendar_label
		hbox3.show()
		self.hbox3=hbox3

		hbox4=GtkHBox()
		vbox1.pack_start(hbox4, TRUE, TRUE, 0)
		hbox4.set_usize(-1, -1)
		hbox4.set_homogeneous(FALSE)
		hbox4.set_spacing(0)
		pix, mask = create_pixmap_from_xpm(self.parent.window, None, self.parent.config[2] + "/pixmaps/storm-tasks.xpm")
		tasks_pixmap=GtkPixmap(pix, mask)
		hbox4.pack_start(tasks_pixmap, FALSE, FALSE, 0)
		tasks_pixmap.set_usize(-1, -1)
		tasks_pixmap.set_alignment(0.5, 0.5)
		tasks_pixmap.set_padding(5, 0)
		tasks_pixmap.show()
		self.tasks_pixmap=tasks_pixmap
		tasks_label=GtkLabel()
		tasks_label.set_name("tasks_label")
#		rc_parse_string('widget "*tasks_label*" style "storm_normal"') 
		hbox4.pack_start(tasks_label, FALSE, FALSE, 0)
		tasks_label.set_usize(-1, -1)
		tasks_label.set_justify(JUSTIFY_LEFT)
		tasks_label.set_alignment(0.5, 0.5)
		tasks_label.set_padding(0, 0)
		tasks_label.show()
		self.tasks_label=tasks_label
		hbox4.show()
		self.hbox4=hbox4

		vbox1.show()
		self.vbox1=vbox1

		frame.show()
		self.frame = frame

		self.update_today()


	def update_today_datetime(self, *args):
		'''Update date and time of the Today page.'''
		
		# Update the date/time
		datetime = time.strftime("%a, %d %b %Y, %H:%M %p", time.localtime(time.time()))
		self.frame.set_label("Today (" + datetime + ")")

	def update_today(self, *args):
		'''Update the Today page with the latest things.'''

		self.update_today_datetime()

		# Update the email message count
		maildir_folders = os.listdir(self.parent.storm_usermaildirdir)
		label_str = ''
		for folder in maildir_folders:
			if folder != "CVS":
				num = 0
				num = num + len(os.listdir(self.parent.storm_usermaildirdir + folder + '/new'))
				label_str = label_str + folder + ': ' + str(num)
				num = num + len(os.listdir(self.parent.storm_usermaildirdir + folder + '/cur'))
				label_str = label_str + ' new, ' + str(num) + ' total\n'
		# Add the text to the gtk label
		self.inbox_label.set_text(label_str[:-1])

		# Update the number of appointments for today
		x = 0
		appointments_num = 0
# TODO: (Work in progress.) Don't show "Next appt is today" if the
# appt has already occured. Also print how many appts are left
# today. [CM]
#		appts_left_today = 0
		curday = time.strftime("%d", time.localtime(time.time()))
#		curtime_epoch = time.time()
#		print "DEBUG: current time is " + str(curtime_epoch)
		while x < len(self.parent.calendar.appt):
			if self.parent.calendar.appt[x][c_Date][c_DateDay] == curday:
				appointments_num = appointments_num + 1
				#today_appt_time = self.parent.calendar.appt[x][c_StartTime][c_StartTimeHour] + ':' + self.parent.calendar.appt[x][c_StartTime][c_StartTimeMin]
				#today_appt_time_str = str(today_appt_time)
				#print "DEBUG: todays appts " + today_appt_time_str
				#print "DEBUG: tuple " + str(time.strptime(today_appt_time_str, "%H:%M"))
				##today_appt_time_epoch = time.strptime(today_appt_time, "%H:%M")
				##today_appt_time_epoch = time.mktime(time.strptime(today_appt_time, "%H:%M"))
				#today_appt_time_epoch = time.mktime(time.strptime("2002 " + today_appt_time_str, "%Y %H:%M"))
				#print "DEBUG: todays appts in epoch " + str(today_appt_time_epoch)
				#if curtime_epoch < today_appt_time_epoch:
				#	print "DEBUG: MEEEEEP"
				#	appts_left_today = appts_left_today + 1
			x = x + 1
		label = 'Appointments: ' + str(appointments_num) + ' today, ' + str(len(self.parent.calendar.appt)) + ' total'
#		label = 'Appointments: ' + str(appointments_num) + ' today (' + str(appts_left_today) + ' left), ' + str(len(self.parent.calendar.appt)) + ' total'
		rc_parse_string('widget "*calendar_label*" style "storm_normal"') 
		self.calendar_label.set_name("calendar_label")

		# find the next appointment:
		if len(self.parent.calendar.appt) > 0:
			# !!! TODO: appts need to be sorted. now it depends on the order in which they are created [CM]
#			print "DEBUG: Checking appt on day " + self.parent.calendar.appt[x-1][c_Date][c_DateDay]
#			print "DEBUG: Today is day " + str(int(curday))

			# ugly:
			curhour = int(time.strftime("%H", time.localtime(time.time())))
			curmin  = int(time.strftime("%M", time.localtime(time.time())))
			
			if self.parent.calendar.appt[x-1][c_Date][c_DateDay] == curday and \
			   curhour <= self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeHour] and \
			   curmin  <= self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeMin]:
				appoint_date = 'today at ' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeHour] + ':' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeMin]
				print "DEBUG: appt left today is at " + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeHour] + ':' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeMin]

				# make text bold:
				rc_parse_string('widget "*calendar_label*" style "storm_appt_today"') 

				if self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeHour] <= str(curhour + 1):
					print "DEBUG: appt left today is CLOSE!"
					rc_parse_string('widget "*calendar_label*" style "storm_appt_upcoming"')
 				self.calendar_label.set_name("calendar_label")

			elif self.parent.calendar.appt[x-1][c_Date][c_DateDay] == str(int(curday) + 1):
				appoint_date = 'tomorrow at ' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeHour] + ':' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeMin]
				print "DEBUG: appt tomorrow is at " + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeHour] + ':' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeMin]
			else:
				appoint_date = 'on ' + time.strftime("%a, %b %d %Y", time.strptime(time.strftime("%b %d %Y", (int(self.parent.calendar.appt[x-1][c_Date][c_DateYear]), int(self.parent.calendar.appt[x-1][c_Date][c_DateMonth]), int(self.parent.calendar.appt[x-1][c_Date][c_DateDay]), 0, 0, 0, 0, 0, 0)), "%b %d %Y")) + ' at ' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeHour] + ':' + self.parent.calendar.appt[x-1][c_StartTime][c_StartTimeMin]
				print "DEBUG: appt is neither today nor tomorrow."

			label = label + '\nNext is ' + appoint_date
		self.calendar_label.set_text(label)
		# TODO: if the next appt is really close, print it in bold font [CM]

		
		# Update the number of tasks
		x = 0
		tasks_done = 0
		tasks_not_done = 0
		print 'Tasks ' + str(len(self.parent.tasks.task))
		while x < len(self.parent.tasks.task):
			if self.parent.tasks.task[x][3] == '1':
				tasks_done = tasks_done + 1
			elif self.parent.tasks.task[x][3] == '0':
				tasks_not_done = tasks_not_done + 1
			x = x + 1
		self.tasks_label.set_text('Tasks: ' + str(tasks_done) + ' completed, ' + str(tasks_not_done) + ' remaining')

